#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>


void init_generateur_alea(){
  srand(time(NULL));
}


void swap(int *x,int *y)
{
   int temp;
   temp = *x;
   *x   = *y;
   *y   = temp;
}
 
 
void quicksort(int list[], int m, int n, int *cout)
{
   int key, i, j;
   if( m < n)
   {

      key = list[m];
      i = m+1;
      j = n;
      while(i <= j)
      {
	while((i <= n) && (list[i] <= key)){
	  (*cout)++;
	  i++;
	}
	while((j >= m) && (list[j] > key)){
	  (*cout)++;
	  j--;
	}
         if( i < j){
	   swap(&list[i],&list[j]);
	 }
      }
      // swap two elements
      swap(&list[m],&list[j]);
      // recursively sort the lesser list
      quicksort(list, m, j-1, cout);
      quicksort(list, j+1, n, cout);
   }
}


int main(int argc, char *argv[])
{

  if(argc != 3){
    printf("\n   usage: ./algo nbElementTri  nbIterations \n\n");
    exit(0);
  }


   int *list;
   int maxElem = atoi(argv[1]);
   int nbIter  = atoi(argv[2]);
   int i, j;
   int cout;

   struct timeval tv1,tv2;
   double duree;

   list = (int*)malloc(maxElem*sizeof(int));

   for(j=0; j<nbIter+100; j++)
   {     

   // generate random numbers and fill them to the list
   for(i = 0; i < maxElem; i++ ){
     list[i] = rand();
   }
   
   gettimeofday(&tv1, NULL);
   cout = 0;

   // sort the list using quicksort
   quicksort(list, 0, maxElem-1, &cout);

   gettimeofday(&tv2, NULL);
   
   duree = (tv2.tv_sec-tv1.tv_sec) * 1000000 + (tv2.tv_usec-tv1.tv_usec);

   /*Pour supprimer problème de cache */
   if(j>100){
     printf("%d  %.2f  %d\n", maxElem, duree, cout);
   }

   }
   
   free(list);
   return 0;
}
